# -*- coding: utf-8 -*-
from odoo import http
from odoo.http import request
import logging
import math
from datetime import date,datetime,timedelta
import requests
import werkzeug
import json

_logger = logging.getLogger(__name__)

class OrderInfoController(http.Controller):
    @http.route('/order/get_order_info', methods=['POST'], type='json', auth='public')
    def get_order_info(self, order_id, **kwargs):
        if order_id:
            order = request.env['pos.order'].sudo().browse(order_id)
            if order:
                return {'state': 'success',
                        'name': order.pos_reference,
                        'UniversalID': order.UniversalID,
                        'pay_kkm_guid': order.pay_kkm_guid,
                        'pay_cancel_kkm_guid': order.pay_cancel_kkm_guid,
                        'pay_return_kkm_guid': order.pay_return_kkm_guid,
                        }
            else:
                return {'state': 'error', 'message': 'Не удалось найти возврат.'}
        else:
            return {'state': 'error', 'message': 'Отсутствует идентификатор возврата.'}

class LoggerJSMessage(http.Controller):
    @http.route('/loggerjs/message', methods=['POST'], type='json', auth='public')
    def get_order_info(self, Level, Message, **kwargs):
        if Level=='warning':
            _logger.warning(Message)
        elif Level=='info':
            #_logger.info(Message)
            _logger.warning(Message)
        elif Level=='error':
            _logger.error(Message)
        else:
            _logger.warning(Message)
        return Message

class CashierInfo(http.Controller):
    @http.route('/cashier/info', methods=['POST'], type='json', auth='public')
    def get_order_info(self, cashier_id, **kwargs):
        res = {}
        if cashier_id:
            cashier = request.env['res.users'].sudo().browse(cashier_id)
            if cashier:
                res = {
                    'name': cashier.name,
                    'inn':cashier.inn
                }
        return res