import json

from odoo import fields, models

class ProductTemplate(models.Model):
    _inherit = 'product.template'

    barcode_json = fields.Char(
        "Barcode", readonly=True, compute="_compute_barcode_json"
    )

    def _compute_barcode_json(self):
        for b in self:
            barcode_json = [x for x in  b.mapped('product.barcode') if x]
            b.barcode_json = json.dumps(barcode_json)