/** @odoo-module **/

import models from 'point_of_sale.models';
import {Order} from 'point_of_sale.models';
import  Registries from "point_of_sale.Registries";
const KKMUniversalID = (Order) => class KKMUniversalID extends Order {
     constructor() {
     super(...arguments);
     this.UniversalID = this.UniversalID || null;
     this.UniversalIDRefund = this.UniversalIDRefund || null;
     this.pay_kkm_guid = this.pay_kkm_guid || null;
     this.pay_cancel_kkm_guid = this.pay_cancel_kkm_guid || null;
     this.pay_return_kkm_guid = this.pay_return_kkm_guid || null;
     }

     set_kkm_UniversalID(UniversalID){
     this.UniversalID = UniversalID
     }

     set_kkm_UniversalIDRefund(UniversalIDRefund){
     this.UniversalIDRefund = UniversalIDRefund
     }

     set_kkm_pay_kkm_guid(pay_kkm_guid){
     this.pay_kkm_guid = pay_kkm_guid
     }

     set_kkm_pay_cancel_kkm_guid(pay_cancel_kkm_guid){
     this.pay_cancel_kkm_guid = pay_cancel_kkm_guid
     }

     set_kkm_pay_return_kkm_guid(pay_return_kkm_guid){
     this.pay_return_kkm_guid = pay_return_kkm_guid
     }

     export_as_JSON() {
     const json = super.export_as_JSON(...arguments)
     json.UniversalID = this.UniversalID;
     json.UniversalIDRefund = this.UniversalIDRefund;
     json.pay_kkm_guid = this.pay_kkm_guid;
     json.pay_cancel_kkm_guid = this.pay_cancel_kkm_guid;
     json.pay_return_kkm_guid = this.pay_return_kkm_guid;
     return json;
     }

     init_from_JSON(json) {
     super.init_from_JSON(...arguments);
     this.UniversalID = json.UniversalID;
     this.UniversalIDRefund = json.UniversalIDRefund;
     this.pay_kkm_guid = json.pay_kkm_guid;
     this.pay_cancel_kkm_guid = json.pay_cancel_kkm_guid;
     this.pay_return_kkm_guid = json.pay_return_kkm_guid;
     }

      is_electronic_pay_kkm(){
        var paymentlines =  this.get_paymentlines();
        var Amount = 0;
        for (var i = 0; i < paymentlines.length; i++) {
            if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
        };
        if (Amount<0) {
            return false
        }
        else{
            return true
        }
      }

      is_electronic_pay_kkm_exist(){
        var paymentlines =  this.get_paymentlines();
        var Amount = 0;
        for (var i = 0; i < paymentlines.length; i++) {
            if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
        };
        if (Amount!=0) {
            return true
        }
        else{
            return false
        }
      }

     };

 Registries.Model.extend(Order, KKMUniversalID);