/*
    Copyright 2022 Camptocamp SA (https://www.camptocamp.com).
    License AGPL-3.0 or later (https://www.gnu.org/licenses/agpl).
*/
odoo.define("pos_lot_selection.ProductScreen", function (require) {
    "use strict";

    const ProductScreen = require("point_of_sale.ProductScreen");
    const Registries = require("point_of_sale.Registries");
    const { Gui } = require('point_of_sale.Gui');

    window.lotErrorPopup = function(product) {
        // Use the Gui object here
        Gui.showPopup('ErrorPopup', {
          'title': 'Ошибка ЧЗ',
          'body': `Введенный код маркировки отсутсвует на складе`,
        });
      };

    const PosLotSaleProductScreen = (OriginalProductScreen) =>
        class extends OriginalProductScreen {
            /**
             * @override
             */
            async _getAddProductOptions(product) {
                if (["serial", "lot"].includes(product.tracking)) {
                    this.env.session.lots = await this.env.pos.getProductLots(product);
                    window.availableLots = this.env.session.lots;
                    console.log('this.env.session.lots',this.env.session.lots);
                    if (this.env.session.lots.length > 0) {
                        const res = await super._getAddProductOptions(...arguments);
                        window.selectedLot = res.draftPackLotLines.newPackLotLines[0].lot_name;
                        if (window.availableLots.includes(window.selectedLot)) {
                            console.log('window.selectedLot',window.selectedLot);
                            return res;
                        }
                    }
                    window.lotErrorPopup(product);
                    window.lot_error = true;
                    return;
                }
                const res = await super._getAddProductOptions(...arguments);
                this.env.session.lots = undefined;

                return res;
            }
        };

    Registries.Component.extend(ProductScreen, PosLotSaleProductScreen);
    return ProductScreen;
});
